<template>
  <div>
    <CityFilter :city-filter="filter" @submit="fetchData" />
    <div>
      <el-table
        :data="cityPage.content"
        :show-header="false"
        :height="800"
        :empty-text="noData"
      >
        <el-table-column prop="id" label="id" width="60" />
        <el-table-column prop="name" label="name" width="200" />
        <el-table-column prop="photo" label="photo" width="300">
          <template #default="scope">
            <CityPhoto :src="scope.row.photo" />
          </template>
        </el-table-column>
        <el-table-column label="actions">
          <template #default="scope">
            <CityEditDialog :onOk="onUpdate" :city="scope.row" />
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        v-show="cityPage.content && cityPage.content.length > 0"
        @size-change="onSizeChange"
        @current-change="onCurrentChange"
        :currentPage="currentPage"
        :total="cityPage.totalElements ?? 0"
        :page-sizes="[5, 10, 20]"
        layout="total, sizes, prev, pager, next, jumper"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import type { FindAllRequest, PageCity } from "@/api";
import { CityControllerApi, type CityUpdateDto } from "@/api";
import CityPhoto from "@/component/CityPhoto.vue";
import CityFilter from "@/component/CityFilter.vue";
import CityEditDialog from "@/component/CityEditDialog.vue";

export interface Filter {
  name: string;
}

export default defineComponent({
  name: "CityList",
  components: { CityEditDialog, CityFilter, CityPhoto },
  data: () => ({
    cityPage: {} as PageCity,
    pageRequest: {} as FindAllRequest,
    filter: {} as Filter,
  }),
  mounted() {
    this.fetchData();
  },
  methods: {
    async fetchData() {
      this.cityPage = await new CityControllerApi().findAll({
        ...this.pageRequest,
        ...this.filter,
      });
    },
    onCurrentChange(newPageNumber: number): void {
      this.pageRequest.page = newPageNumber - 1;
      this.fetchData();
    },
    onSizeChange(newSize: number): void {
      this.pageRequest.size = newSize;
      if (
        this.pageRequest.page === undefined ||
        this.pageRequest.page * newSize <= (this.cityPage.totalElements ?? 0)
      ) {
        this.fetchData();
      }
    },
    async onUpdate(id: number, city: CityUpdateDto): Promise<void> {
      const updatedCity = await new CityControllerApi().update({
        id: id,
        cityUpdateDto: city,
      });
      if (this.cityPage.content) {
        this.cityPage.content = this.cityPage.content.map((c) =>
          c.id === updatedCity.id ? { ...c, ...updatedCity } : c
        );
      }
    },
  },
  computed: {
    currentPage(): number {
      return this.cityPage.number ? this.cityPage.number + 1 : 1;
    },
    noData(): string {
      return "No cities containing '" + this.filter.name + "' in name found ";
    },
  },
});
</script>
